{% extends "base.html" %}
{% load static %}
{% load static %}
{% block stylesheet %}

<link href="{% static 'css/plugins/sweetalert/sweetalert.css' %}" rel="stylesheet">
{% endblock stylesheet %}



{% block content %}

<div class="row">
    <div class="col-md-12">
        <div class="ibox">
            <div class="ibox-title bg-success">
                <h5 style="font-size:20px">Solicitudes Pendientes</h5>
            </div>
            <div class="ibox-content">
                <div class="row">
                    <table class="table table-bordered">
                        <thead>
                            <th class="text-center">Tipo</th>
                            <th class="text-center">Alumno</th>
                            <th class="text-center">Fecha de Solicitud</th>
                            <th class="text-center">Empresa</th>
                            <th class="text-center">Acciones</th>
                        </thead>
                        <tbody>
                            {% for x in solicitudes %}
                            {% if x.respuestasolicitud_set.all.count == 0 %}
                            <tr>
                                <td style="vertical-align:middle;" class="text-center col-md-2">Práctica Profesional</td>
                                <td style="vertical-align:middle;" class="text-center col-md-2">{{x.alumno.nombre}}</td>
                                <td style="vertical-align:middle;" class="text-center col-md-2">{{x.created}}</td>
                                <td style="vertical-align:middle;" class="text-center col-md-3">{{x.empresa.nombre}}</td>
                                <td style="vertical-align:middle;" class="text-center col-md-3">
                                    <button data-file="{{x.file}}" data-toggle="modal" data-target="#documentoModal" class="btn btn-sm btn-warning"><i class="fa fa-eye"></i> Ver Documento</button>
                                    <button data-pk="{{x.pk}}" data-toggle="modal" data-target="#modalAprobar" class="btn btn-sm btn-primary"><i class="fa fa-check"></i> Aprobar</button>
                                    <button data-pk="{{x.pk}}" data-toggle="modal" data-target="#modalRechazar" class="btn btn-sm btn-danger"><i class="fa fa-times"></i> Rechazar</button>
                                </td>
                            </tr>
                            {% endif %}
                            {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- modal block -->

        <div class="modal fade" id="documentoModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
          <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
            <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                  <h1 class="text-center" id="titulo-proyecto">Documento de la solicitud</h1>
            </div>
              <div class="modal-body">
                  <div class="text-center pdf-toolbar">
                        <div class="btn-group">
                            <button id="prev" class="btn btn-white"><i class="fa fa-long-arrow-left"></i> <span class="hidden-xs">Pagina Anterior</span></button>
                            <button id="next" class="btn btn-white"><i class="fa fa-long-arrow-right"></i> <span class="hidden-xs">Pagina Siguiente</span></button>
                            <span class="btn btn-white hidden-xs">Pagina: </span>

                        <div class="input-group">
                            <input type="text" class="form-control" id="page_num">

                            <div class="input-group-btn">
                                <button type="button" class="btn btn-white" id="page_count">/ 22</button>
                            </div>
                        </div>
                        </div>
                    </div>
                    <div class="text-center m-t-md">
                        <canvas id="the-canvas" class="pdfcanvas border-left-right border-top-bottom b-r-md"></canvas>
                    </div>
              </div>
              <div class="modal-footer">
              </div>
            </div>
          </div>
        </div>

<!-- end modal block -->
<!-- modal block -->

        <div class="modal fade" id="modalAprobar" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
          <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
            <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                  <h1 class="text-center" id="titulo-proyecto">Aprobar Solicitud</h1>
            </div>
              <div class="modal-body">
                <form action="{% url 'aprobar_solicitud_dsa' %}" method="post">
                {% csrf_token %}
                 <input style="display:none" id="pk_solicitud_aprobar" name="pk_solicitud_aprobar" type="text">
                  <div class="form-group">
                      <label for="comentario" class="control-label">Observación: </label>
                      <textarea required class="form-control" name="comentario" id="comentario" rows="5"></textarea>
                  </div>
              </div>
              <div class="modal-footer">
                  <button type="submit" class="btn btn-block btn-primary"><i class="fa fa-check"></i> Aprobar</button>
                  </form>
              </div>
            </div>
          </div>
        </div>

<!-- end modal block -->
<!-- modal block -->

        <div class="modal fade" id="modalRechazar" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel">
          <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
            <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                  <h1 class="text-center" id="titulo-proyecto">Rechazar Solicitud</h1>
            </div>
            <div class="modal-body">
             <input style="display:none" id="pk_solicitud" name="pk_solicitud" type="text">
              <div class="form-group">
                  <label for="comentario" class="control-label">Observación: </label>
                  <textarea class="form-control" name="comentario" id="comentario" rows="5"></textarea>
              </div>
            </div>
            <div class="modal-footer">
              <button class="btn btn-block btn-danger"><i class="fa fa-times"></i> Rechazar</button>
            </div>
            </div>
          </div>
        </div>

<!-- end modal block -->
{% endblock content %}


{% block javascript %}

<script src="{% static 'js/plugins/pdfjs/pdf.js' %}"></script>


<script>

$(document).ready(function(){
    
    $("li").removeClass("active");
    $("#ds_solicitudes_pendientes").addClass("active");
    
    $('#modalAprobar').on('show.bs.modal', function (event) {
        var button = $(event.relatedTarget) // Button that triggered the modal
        var pk = button.data('pk') // Extract info from data-* attributes
        $("#pk_solicitud_aprobar").val(pk);        
    }); 
    
     $('#documentoModal').on('show.bs.modal', function (event) {
        var button = $(event.relatedTarget) // Button that triggered the modal
        var file = button.data('file') // Extract info from data-* attributes
        
        var url = '/media/' + file;


        var pdfDoc = null,
                pageNum = 1,
                pageRendering = false,
                pageNumPending = null,
                scale = 1.25,
                zoomRange = 0.25,
                canvas = document.getElementById('the-canvas'),
                ctx = canvas.getContext('2d');

        /**
         * Get page info from document, resize canvas accordingly, and render page.
         * @param num Page number.
         */
        function renderPage(num, scale) {
            pageRendering = true;
            // Using promise to fetch the page
            pdfDoc.getPage(num).then(function(page) {
                var viewport = page.getViewport(scale);
                canvas.height = viewport.height;
                canvas.width = viewport.width;

                // Render PDF page into canvas context
                var renderContext = {
                    canvasContext: ctx,
                    viewport: viewport
                };
                var renderTask = page.render(renderContext);

                // Wait for rendering to finish
                renderTask.promise.then(function () {
                    pageRendering = false;
                    if (pageNumPending !== null) {
                        // New page rendering is pending
                        renderPage(pageNumPending);
                        pageNumPending = null;
                    }
                });
            });

            // Update page counters
            document.getElementById('page_num').value = num;
        }

        /**
         * If another page rendering in progress, waits until the rendering is
         * finised. Otherwise, executes rendering immediately.
         */
        function queueRenderPage(num) {
            if (pageRendering) {
                pageNumPending = num;
            } else {
                renderPage(num,scale);
            }
        }

        /**
         * Displays previous page.
         */
        function onPrevPage() {
            if (pageNum <= 1) {
                return;
            }
            pageNum--;
            var scale = pdfDoc.scale;
            queueRenderPage(pageNum, scale);
        }
        document.getElementById('prev').addEventListener('click', onPrevPage);

        /**
         * Displays next page.
         */
        function onNextPage() {
            if (pageNum >= pdfDoc.numPages) {
                return;
            }
            pageNum++;
            var scale = pdfDoc.scale;
            queueRenderPage(pageNum, scale);
        }
        document.getElementById('next').addEventListener('click', onNextPage);

        /**
         * Zoom in page.
         */
        function onZoomIn() {
            if (scale >= pdfDoc.scale) {
                return;
            }
            scale += zoomRange;
            var num = pageNum;
            renderPage(num, scale)
        }

        /**
         * Zoom out page.
         */
        function onZoomOut() {
            if (scale >= pdfDoc.scale) {
                return;
            }
            scale -= zoomRange;
            var num = pageNum;
            queueRenderPage(num, scale);
        }

        /**
         * Zoom fit page.
         */
        function onZoomFit() {
            if (scale >= pdfDoc.scale) {
                return;
            }
            scale = 1;
            var num = pageNum;
            queueRenderPage(num, scale);
        }


        /**
         * Asynchronously downloads PDF.
         */
        PDFJS.getDocument(url).then(function (pdfDoc_) {
            pdfDoc = pdfDoc_;
            var documentPagesNumber = pdfDoc.numPages;
            document.getElementById('page_count').textContent = '/ ' + documentPagesNumber;

            $('#page_num').on('change', function() {
                var pageNumber = Number($(this).val());

                if(pageNumber > 0 && pageNumber <= documentPagesNumber) {
                    queueRenderPage(pageNumber, scale);
                }

            });

            // Initial/first page rendering
            renderPage(pageNum, scale);
        });
        
    });
    
})


</script>




{% endblock javascript %}